
/* Subroutine */ int de70dq_c(integer *m, integer *n, doublereal *zfi,
	doublereal *cmar, doublereal *ajk)
{
    /* System generated locals */
    integer zfi_dim1, zfi_offset, cmar_dim1, cmar_offset, ajk_dim1,
	    ajk_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer i__, j, l, i1, jp1, np1;

    /* Parameter adjustments */
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    cmar_dim1 = *n;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;

    /* Function Body */
    np1 = *n + 1;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	ajk[l + np1 * ajk_dim1] = 0.f;
    }
/*        CALCULATE AJ0 */
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	jp1 = j + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    ajk[l + np1 * ajk_dim1] += zfi[l + jp1 * zfi_dim1];
/* L20: */
	}
/* L30: */
    }
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L40: */
	ajk[l + ajk_dim1] = zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[l + np1 *
		ajk_dim1];
    }
/*        CALCULATE AJ1,AJ3,AJ5,... */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; i__ += 2) {
	i1 = i__ + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L50: */
	    ajk[l + np1 * ajk_dim1] = 0.f;
	}
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    jp1 = j + 1;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		ajk[l + np1 * ajk_dim1] += cmar[i__ + j * cmar_dim1] * zfi[l
			+ jp1 * zfi_dim1];
/* L60: */
	    }
/* L70: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L80: */
	    ajk[l + i1 * ajk_dim1] = -zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[
		    l + np1 * ajk_dim1];
	}
/* L90: */
    }
/*        CALCULATE AJ2,AJ4,AJ6,... */
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; i__ += 2) {
	i1 = i__ + 1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L100: */
	    ajk[l + com70d_1.lasn * ajk_dim1] = 0.f;
	}
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    jp1 = j + 1;
	    i__3 = *m;
	    for (l = 1; l <= i__3; ++l) {
		ajk[l + com70d_1.lasn * ajk_dim1] += cmar[i__ + j * cmar_dim1]
			 * zfi[l + jp1 * zfi_dim1];
/* L110: */
	    }
/* L120: */
	}
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L130: */
	    ajk[l + i1 * ajk_dim1] = zfi[l + zfi_dim1] + com70d_1.wc3 * ajk[l
		    + com70d_1.lasn * ajk_dim1];
	}
/* L140: */
    }
    return 0;
} /* de70dq_c */
