#include "f2c.h"

/* Common Block Declarations */
struct {
    doublereal wc1, wc2, wc3, hd2, hd4, hold;
    integer lasn;
} com70d_;

#define com70d_1 com70d_

struct {
    integer jlas, jlas1, jlas2, jlas3;
    doublereal h2d4, h2d8, h2d16, h2d32, h2d96;
} com80d_;

#define com80d_1 com80d_

/* Subroutine */ int de88d_c(U_fp f, integer *m, doublereal *xn, doublereal *
	yn, doublereal *dyn, doublereal *xk, integer *k, integer *iniapr,
	integer *imax, integer *iordy, doublereal *h__, doublereal *y,
	doublereal *dy, integer *nx, doublereal *xs, doublereal *ay,
	doublereal *ady, doublereal *ad2y, doublereal *rab)
{
    /* System generated locals */
    integer ay_dim1, ay_offset, ady_dim1, ady_offset, ad2y_dim1, ad2y_offset,
	    i__1, i__2;
    doublereal d__1;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static integer j, l;
    static doublereal x, h1;
    static integer i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13,
	     i14, i15, i16;
    static doublereal hs;
    static integer jt, kp1, kp2, kp3;
    static logical bul;
    static integer jtp;
    extern /* Subroutine */ int de78d_c(U_fp, integer *, integer *, integer *,
	    integer *, integer *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *, doublereal *, doublereal *,
	    doublereal *, doublereal *);
    static integer nxay, imax0, nxady, nad2yp, nxad2y, jstart;

    /* Parameter adjustments */
    ad2y_dim1 = *m;
    ad2y_offset = 1 + ad2y_dim1;
    ad2y -= ad2y_offset;
    ady_dim1 = *m;
    ady_offset = 1 + ady_dim1;
    ady -= ady_offset;
    ay_dim1 = *m;
    ay_offset = 1 + ay_dim1;
    ay -= ay_offset;
    --dy;
    --y;
    --dyn;
    --yn;
    --xs;
    --rab;

    /* Function Body */
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	y[l] = yn[l];
/* L10: */
	dy[l] = dyn[l];
    }
    *nx = 0;
    xs[1] = *xn;
    if (*xn == *xk) {
	goto L100;
    }
    d__1 = *xk - *xn;
    *h__ = d_sign(h__, &d__1);
    bul = FALSE_;
    jstart = 0;
    imax0 = *imax;
    if (*iniapr > 1 && *imax <= *k) {
	imax0 = *k + *iniapr - 1;
    }
    kp1 = *k + 1;
    kp2 = *k + 2;
    kp3 = *k + 3;
    nxay = 1;
    nxady = 1;
    nxad2y = 1;
    x = *xn;
    i0 = kp1;
    i1 = i0 + kp1;
    i2 = i1 + *k;
    i3 = i2 + *k;
    i4 = i3 + *k;
    i5 = i4 + *k * *k;
    i6 = i5 + kp2 * (*k - 1) / 2;
    i7 = i6 + kp3 * *k / 2;
    i8 = i7 + 1;
    i9 = i8 + *m;
    i10 = i9 + kp1 * *m;
    i11 = i10 + *k * *m;
    i12 = i11 + kp3 * *m;
    i13 = i12 + *k;
    i14 = i13 + kp2;
    i15 = i14 + kp2;
    i16 = i15 + *m;
L30:
    if (! bul) {
	goto L40;
    }
    *h__ = hs;
    goto L100;
L40:
    if (jstart == 1) {
	imax0 = *imax;
    }
    h1 = *xk - x;
    if (abs(h1) > abs(*h__)) {
	goto L50;
    }
    hs = *h__;
    *h__ = h1;
    bul = TRUE_;
L50:
    de78d_c((U_fp)f, m, k, iniapr, &imax0, &jstart, &y[1], &dy[1], &x, &rab[1],
	     &ay[nxay * ay_dim1 + 1], &ady[nxady * ady_dim1 + 1], &ad2y[
	    nxad2y * ad2y_dim1 + 1], h__, &rab[i0], &rab[i1], &rab[i12], &rab[
	    i13], &rab[i14], &rab[i2], &rab[i3], &rab[i4], &rab[i5], &rab[i6],
	     &rab[i7], &rab[i8], &rab[i15], &rab[i9], &rab[i10], &rab[i16], &
	    rab[i11]);
    ++(*nx);
    xs[*nx + 1] = x;
    nxay += kp3;
    if (*iordy == 0) {
	goto L30;
    }
    nxady += kp2;
    if (*iordy == 1) {
	goto L30;
    }
    if (*iordy != 2) {
	goto L100;
    }
    if (bul) {
	goto L30;
    }
    nad2yp = nxad2y;
    nxad2y += kp1;
    i__1 = kp1;
    for (j = 1; j <= i__1; ++j) {
	jtp = nad2yp - 1 + j;
	jt = nxad2y - 1 + j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L60: */
	    ad2y[l + jt * ad2y_dim1] = ad2y[l + jtp * ad2y_dim1];
	}
/* L70: */
    }
    goto L30;
L100:
    return 0;
} /* de88d_c */
