
/* Subroutine */ int de71dt_c(integer *m, integer *k, doublereal *z__,
	                      doublereal *ksi)
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2;

    /* Local variables */
    static integer j, l;
    static doublereal t, ksi1;

    /* Parameter adjustments */
    z_dim1 = *m;
    z_offset = 1 + z_dim1;
    z__ -= z_offset;

    /* Function Body */
    t = 1.;
    ksi1 = *ksi + 1.;
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	t *= ksi1;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L10: */
	    z__[l + (j + 1) * z_dim1] *= t;
	}
/* L20: */
    }
    return 0;
} /* de71dt_c */
